//+------------------------------------------------------------------+
//|                                             _KG_Market_Hours.mq4 |
//|                                                            d4y47 |
//|                                      http://www.kgforexworld.com |
//+------------------------------------------------------------------+
#property copyright "d4y47"
#property link      "http://www.kgforexworld.com"

#property 		indicator_chart_window
#property		indicator_buffers 4
#property		indicator_color1 Green
#property		indicator_width1 2
#property		indicator_color2 Crimson
#property		indicator_width2 2
#property		indicator_color3 Blue
#property		indicator_width3 2
#property		indicator_color4 DarkOrange
#property		indicator_width4 2
#property 		indicator_maximum 9
#property 		indicator_minimum 0

extern int		LondonOpen		= 10;
extern int		LondonClose		= 19;
extern int		NewYorkOpen		= 16;
extern int		NewYorkClose	= 0;
extern int		SydneyOpen		= 0;
extern int		SydneyClose		= 9;
extern int		TokyoOpen		= 2;
extern int		TokyoClose		= 11;

// Buffers
double dLondonBuffer[];
double dNewYorkBuffer[];
double dSydneyBuffer[];
double dTokyoBuffer[];
double tmpLondon,tmpTokyo,tmpSydney,tmpNewyork;
int init() {

	IndicatorShortName("");
	
	SetIndexBuffer(0,dLondonBuffer);
	SetIndexLabel(0,"London");
	SetIndexBuffer(1,dNewYorkBuffer);
	SetIndexLabel(1,"New York");
	SetIndexBuffer(2,dSydneyBuffer);
	SetIndexLabel(2,"Sydney");
	SetIndexBuffer(3,dTokyoBuffer);
	SetIndexLabel(3,"Tokyo");
	
	return(0);
}

int start() {

	// Determine number of bars to iterate over
	int iBarsToCalc = Bars - IndicatorCounted();
	if (iBarsToCalc < Bars) iBarsToCalc++;
	
	// Iterate over bars
	for (int i=iBarsToCalc-1;i>=0;i--) {
		
		// Set London Line
		if (isMarketOpen(LondonOpen, LondonClose, Time[i])){
		   if (!isMarketOpen(LondonOpen, LondonClose, Time[i+1]))tmpLondon=Open[i];
			dLondonBuffer[i] = tmpLondon;
		}
		else
			dLondonBuffer[i] = EMPTY_VALUE;
		
		// Set NewYork Line
		if (isMarketOpen(NewYorkOpen, NewYorkClose, Time[i])){
		   if (!isMarketOpen(NewYorkOpen, NewYorkClose, Time[i+1]))tmpNewyork=Open[i];
			dNewYorkBuffer[i] = tmpNewyork;
		}
		else
			dNewYorkBuffer[i] = EMPTY_VALUE;		
			
		// Set Sydney Line
		if (isMarketOpen(SydneyOpen, SydneyClose, Time[i])){
			if (!isMarketOpen(SydneyOpen, SydneyClose, Time[i+1]))tmpSydney=Open[i];
			dSydneyBuffer[i] = tmpSydney;
	   }
		else
			dSydneyBuffer[i] = EMPTY_VALUE;	
				
		// Set Tokyo Line
		if (isMarketOpen(TokyoOpen, TokyoClose, Time[i])){
		   if (!isMarketOpen(TokyoOpen, TokyoClose, Time[i+1]))tmpTokyo=Open[i];
			dTokyoBuffer[i] = tmpTokyo;
		}
		else
			dTokyoBuffer[i] = EMPTY_VALUE;	

	}

}

bool isMarketOpen(int iOpenHour, int iCloseHour, datetime timestamp) {

	int iBarHour = TimeHour(timestamp);
	
	if (iOpenHour < iCloseHour && (iBarHour >= iOpenHour && iBarHour < iCloseHour))
		return(true);
	if (iOpenHour > iCloseHour && (iBarHour >= iOpenHour || iBarHour < iCloseHour))
		return(true);
		
	return(false);
}

